#include "testlib.h"

struct TChannel* channels;
struct TDevice* devices;

int main(int argc, char* argv[])
{
    initLogCTest();
    LOGGER_PRINT("%s %s\n","testlib service func - version", VERSION_APP);
    int index;
    int indexCh;
    int ret = GOOD_CODE;
    int countDevices = 0;
    int countChannels = 0;
    int number = 0;
    struct TMil1553Device* devices;
    struct TMil1553Channel* channels;
    int length;
    int lengthCh;
    LOGGER_PRINT("%s\n","----- 1 ----- -----");
    countDevices = mil1553_getCountDevices();
    LOGGER_PRINT("%s %d\n","mil1553_getCountDevices =", countDevices);
    if (countDevices == 0) {
        ret = BAD_CODE;
        goto END;
    }
    LOGGER_PRINT("%s\n","----- 2 ----- -----");
    countChannels = mil1553_getCountChannels();
    LOGGER_PRINT("%s %d\n","mil1553_getCountChannels =", countChannels);
    LOGGER_PRINT("%s\n","----- 3 ----- -----");
    mil1553_getArrayDevices(&devices, &length);
    LOGGER_PRINT("%s %d\n","mil1553_getArrayDevices =", length);
    for (index = 0; index < length; index++) {
        LOGGER_PRINT("%s DEV_ID= %d REV_ID= %d\n", devices[index].mDev.mNameChannel, devices[index].mInfo.device_id, devices[index].mInfo.revision);
    }
    free(devices);
    LOGGER_PRINT("%s\n","----- 4 ----- -----");
    mil1553_getArrayChannels(&channels, &lengthCh);
    LOGGER_PRINT("%s %d\n","mil1553_getArrayChannels =", lengthCh);
    for (index = 0; index < lengthCh; index++) {
        LOGGER_PRINT("%s\n", channels[index].mNameChannel);
    }
    LOGGER_PRINT("%s\n","----- 5 ----- -----");
    mil1553_getArrayDevices(&devices, &length);
    for (index = 0; index < lengthCh; index++) {
        number = mil1553_getNumberDevice(&(channels[index]));
        LOGGER_PRINT("%s mil1553_getNumberDevice = %d\n", channels[index].mNameChannel, number);
    }
    free(devices);
    LOGGER_PRINT("%s\n","----- 6 ----- -----");
    mil1553_getArrayDevices(&devices, &length);
    for (index = 0; index < length; index++) {
        mil1553_getArrayChannelsByDevice(&(devices[index]), &channels, &lengthCh);
        LOGGER_PRINT("%s DEV_ID= %d REV_ID= %d channels = %d\n", devices[index].mDev.mNameChannel, devices[index].mInfo.device_id, devices[index].mInfo.revision, lengthCh);
        for (indexCh = 0; indexCh < lengthCh; indexCh++) {
            LOGGER_PRINT("%s\n", channels[indexCh].mNameChannel);
        }
        free(channels);
    }
    free(devices);

END:
    LOGGER_FLUSH();
    LOGGER_CLOSE();
    return ret;
}

void initLogCTest(void) {
    char filename[LOGGER_FILENAME_LENGTH];
    constructLogFilename(filename, LOGGER_FILENAME_LENGTH, "testlib");
    LOGGER_OPEN(filename);
}

